﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using System.IO;
using C1.WPF.Pdf;
using C1.WPF.FlexGrid;
using Printing;

namespace WPF_Flex_ExportFilteredRows
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            c1Flexgrid1.ItemsSource = MyDataTable().DefaultView;
            
        }

        public DataTable MyDataTable()
        {
            DataTable dtsource = new DataTable();

            //Adding columns to datatable
            dtsource.Columns.Add("UserId");
            dtsource.Columns.Add("Name");
            dtsource.Columns.Add("Age");
            dtsource.Columns.Add("Address");
            dtsource.Columns.Add("Sex");
            dtsource.Columns.Add("DOB");
            dtsource.Columns.Add("Year");
            dtsource.Columns.Add("Designation");

            //Adding records to the datatable
            dtsource.Rows.Add("1", "Name1", "20", "Address1",
                "Male", "20/12/1978", "1978", "Student");
            dtsource.Rows.Add("2", "Name2", "21", "Address2",
                "Male", "20/12/1984", "1984", "Doctor");
            dtsource.Rows.Add("3", "Name3", "22", "Address3",
                "Male", "10/11/1943", "1943", "Software Eng.");
            dtsource.Rows.Add("4", "Name4", "23", "Address4",
                "Male", "12/12/1956", "1956", "Police man");
            dtsource.Rows.Add("5", "Name5", "24", "Address5",
                "Male", "11/01/1856", "1856", "CEO");
            dtsource.Rows.Add("6", "Name6", "25", "Address6",
                "Female", "29/12/2008", "2008", "Manager");
            dtsource.Rows.Add("7", "Name7", "26", "Address7",
                "Female", "29/12/2004", "2004", "Business man");
            dtsource.Rows.Add("8", "Name8", "27", "Address8",
                "Female", "29/12/1956", "1956", "Student");
            dtsource.Rows.Add("9", "Name9", "28", "Address9",
                "Female", "15/10/2009", "2009", "Project Manager");
            dtsource.Rows.Add("10", "Name10", "29", "Address10",
                "Female", "29/12/2010", "2010", "Doctor");

            //Adding records to the datatable
            dtsource.Rows.Add("1", "Name1", "20", "Address1",
                "Male", "20/12/1978", "1978", "Student");
            dtsource.Rows.Add("2", "Name2", "21", "Address2",
                "Male", "20/12/1984", "1984", "Doctor");
            dtsource.Rows.Add("3", "Name3", "22", "Address3",
                "Male", "10/11/1943", "1943", "Software Eng.");
            dtsource.Rows.Add("4", "Name4", "23", "Address4",
                "Male", "12/12/1956", "1956", "Police man");
            dtsource.Rows.Add("5", "Name5", "24", "Address5",
                "Male", "11/01/1856", "1856", "CEO");
            dtsource.Rows.Add("6", "Name6", "25", "Address6",
                "Female", "29/12/2008", "2008", "Manager");
            dtsource.Rows.Add("7", "Name7", "26", "Address7",
                "Female", "29/12/2004", "2004", "Business man");
            dtsource.Rows.Add("8", "Name8", "27", "Address8",
                "Female", "29/12/1956", "1956", "Student");
            dtsource.Rows.Add("9", "Name9", "28", "Address9",
                "Female", "15/10/2009", "2009", "Project Manager");
            dtsource.Rows.Add("10", "Name10", "29", "Address10",
                "Female", "29/12/2010", "2010", "Doctor");

            return dtsource;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            var dlg = new Microsoft.Win32.SaveFileDialog();
            dlg.DefaultExt = "pdf";
            dlg.Filter = "PDF (*.pdf)|*.pdf";
            if (dlg.ShowDialog().Value)
            {
                using (var s = dlg.OpenFile())
                {
                    SavePdf(s, "ComponentOne PDF");
                }
            }            
        }

        // export the grid to a PDF file
        void SavePdf(Stream s, string documentName)
        {

            // get root element to lay out the PDF pages
            Panel root = null;
            for (var parent = c1Flexgrid1.Parent as FrameworkElement; parent != null; parent = parent.Parent as FrameworkElement)
            {
                if (parent is Panel)
                {
                    root = parent as Panel;
                }
            }

            // create pdf document
            var pdf = new C1PdfDocument(PaperKind.Letter, false);

            // get page size
            var rc = pdf.PageRectangle;
            var m = new Thickness(96, 96, 96 / 2, 96 / 2);
            var scaleMode = ScaleMode.ActualSize;

            // create panel to hold elements while they render
            var pageTemplate = new PageTemplate();
            pageTemplate.Width = rc.Width;
            pageTemplate.Height = rc.Height;
            pageTemplate.SetPageMargin(m);
            root.Children.Add(pageTemplate);

            // render grid into PDF document
            var sz = new Size(rc.Width - m.Left - m.Right, rc.Height - m.Top - m.Bottom);
            var pages = c1Flexgrid1.GetPageImages(scaleMode, sz, 100);
            for (int i = 0; i < pages.Count; i++)
            {
                // skip a page when necessary
                if (i > 0)
                {
                    pdf.NewPage();
                }

                // set content
                pageTemplate.PageContent.Child = pages[i];
                //pageTemplate.PageContent.Stretch = System.Windows.Media.Stretch.Uniform;
                pageTemplate.PageContent.HorizontalAlignment = System.Windows.HorizontalAlignment.Stretch;

                // set header/footer text
                //pageTemplate.HeaderLeft.Text = documentName;
                pageTemplate.FooterRight.Text = string.Format("Page {0} of {1}",
                    i + 1, pages.Count);

                // measure page element
                pageTemplate.Measure(new Size(rc.Width, rc.Height));
                pageTemplate.UpdateLayout();

                // add page element to PDF
                pdf.DrawElement(pageTemplate, rc);
            }

            // done with template
            root.Children.Remove(pageTemplate);

            // save the PDF document
            pdf.Save(s);
            s.Close();

        }
    }
}
